local mod = ...

-- Asset
mod:registerAssetId("models/Butcher1.fbx/Prefab/ButcherPart", "PREFAB_BUTCHER1")
mod:registerAssetId("models/Butcher1.fbx/Prefab/CounterPart", "PREFAB_BUTCHERCOUNTER")



-- Construction Asset
mod:registerAssetId("models/Butcher1.fbx/Prefab/ConstructionSteps", "PREFAB_CONSTR_BUTCHER1")



-- Building Asset Processor
mod:registerAssetProcessor("models/Butcher1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Butcher1.fbx/Prefab/ButcherPart", { "PLATFORM" })



-- Grounding
mod:registerPrefabComponent("models/Butcher1.fbx/Prefab/CounterPart", {DataType = "COMP_GROUNDED"})



-- Paths: Sales counter -------------------------------------------------------------------------------------
mod:registerAssetId("models/Butcher1.fbx/Prefab/CounterPart/PATH_B_1", "PATH_BUTCHER_B1")
mod:registerAssetId("models/Butcher1.fbx/Prefab/CounterPart/PATH_B_2", "PATH_BUTCHER_B2")
mod:registerAssetId("models/Butcher1.fbx/Prefab/CounterPart/PATH_B_3", "PATH_BUTCHER_B3")
mod:registerAssetId("models/Butcher1.fbx/Prefab/CounterPart/PATH_C_1", "PATH_BUTCHER_C1")
mod:registerAssetId("models/Butcher1.fbx/Prefab/CounterPart/PATH_D_1", "PATH_BUTCHER_D1")

mod:registerPrefabComponent("models/Butcher1.fbx/Prefab/CounterPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_BUTCHER_B1", "PATH_BUTCHER_B2", "PATH_BUTCHER_B3" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_BUTCHER_C1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_BUTCHER_D1" }
        },
    }
})



-- Building part type
mod:registerEnumValue("BUILDING_PART_TYPE", "COUNTER")



-- Job -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "BUTCHER_JOB",
	JobName = "BUTCHER_JOB_NAME",
	JobDescription = "BUTCHER_JOB_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 70.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "BUTCHER_JOB"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "BUTCHER_JOB"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "BUTCHER_JOB"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "BUTCHER_JOB"
    }
})



-- Resource: Meat -------------------------------------------------------------------------------------
-- Now available in the Common Resources mod

-- mod:registerAssetId("icons/Meat.png", "ICON_MEAT")

-- mod:register({
-- 	DataType = "RESOURCE",
-- 	Id = "MEAT_RESOURCE",
-- 	ResourceName = "MEAT_RESOURCE_NAME",
-- 	Icon = "ICON_MEAT",
--     ResourceTypeList = { "FOOD", "BUTCHER_RESOURCE_TYPE" },
-- 	IsTradable = true,
-- 	ResourceLayoutType = "CRATES",
-- 	VillagerBuyingPrice = { Resource = "GOLD", Quantity = 14 },
-- 	DisplayInInventory = true
-- })



-- Resource Type: Butcher
-- mod:registerEnumValue( "RESOURCE_TYPE", "BUTCHER_RESOURCE_TYPE" )



-- Building Function: Butcher -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUTCHER_FUNCTION",
    Name = "BUTCHER_FUNCTION_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "BUTCHER_JOB", 
        Behavior = "BEHAVIOR_WORK"
    },
	InputInventoryCapacity = {
		{ Resource = "BV1_CARCASS", Quantity = 25 },
	},
    ResourceListNeeded = {
		{ Resource = "BV1_CARCASS", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "BV1_MEAT", Quantity = 5 },
	}

})



-- Building Function: Butcher Sales Counter -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUTCHERCOUNTER_FUNCTION",
    Name = "BUTCHERCOUNTER_FUNCTION_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        -- Job = "BUTCHER_JOB", 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
        -- Behavior = "BEHAVIOR_MARKET_TENDING"
    },
	TypeList = { "BUTCHER_RESOURCE_TYPE" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "BV1_MEAT", Quantity = 25 },
	},
    ResourceListNeeded = {
		{ Resource = "BV1_MEAT", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "BV1_MEAT", Quantity = 10 },
	}
})



-- Building: Butcher's Shop -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUTCHERSHOP",
	Name = "BUTCHERSHOP_NAME",
	Description = "BUTCHERSHOP_DESC",
	BuildingType = "GENERAL",
	AssetCoreBuildingPart = "BUTCHERSHOP1_PART",
	BuildingPartSetList = {
		{
			Name = "BUTCHERSHOP_SET1_NAME",
			BuildingPartList = { 
				"BUTCHERSHOP1_PART",
			}
		},
		{
			Name = "BUTCHERSHOP_SET2_NAME",
			BuildingPartList = { 
				"BUTCHERSHOP_COUNTER_PART",
			}
		}
	},	
	RequiredPartList = {
		{ Category = "CORE", Min = 1, Max = 1 }
	},
	VillagerRequired = { Status = "COMMONER", Quantity = 5 },
	IsEditable = true
})



-- Building Part: Core -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUTCHERSHOP1_PART",
	Name = "BUTCHERSHOP1_PART_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUTCHER1"
	},
	ConstructionVisual = "PREFAB_CONSTR_BUTCHER1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {5.5, 7.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUTCHER_FUNCTION",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 25 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 10 } },
		RessourcesNeeded = {
            { Resource = "STONE", Quantity = 8 },
            { Resource = "WOOD", Quantity = 10 },
            { Resource = "PLANK", Quantity = 10 },
            { Resource = "TOOL", Quantity = 2 },
		}
	}
})



-- Building Part: Sales Counter -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUTCHERSHOP_COUNTER_PART",
	Name = "BUTCHERSHOP_COUNTER_PART_NAME", 
	Category = "COUNTER",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BUTCHERCOUNTER"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_BUTCHERCOUNTER",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {2, 1.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUTCHERCOUNTER_FUNCTION",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 }
		}
	},
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 25.0,
		Value = 0.5
	} }
})


